weka.gui.explorer

## Class AutoWEKAPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - weka.gui.AbstractPerspective
          - - weka.gui.explorer.ClassifierPanel
            - - weka.gui.explorer.AutoWEKAPanel

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, weka.gui.explorer.Explorer.CapabilitiesFilterChangeListener, weka.gui.explorer.Explorer.ExplorerPanel, weka.gui.explorer.Explorer.LogHandler, weka.gui.Perspective

      public class AutoWEKAPanel
      extends weka.gui.explorer.ClassifierPanel
      implements weka.gui.explorer.Explorer.ExplorerPanel, weka.gui.explorer.Explorer.LogHandler

  This class provides a special, simple panel for Auto-WEKA in the Explorer.
  Version:
    $Revision: 908 $
  Author:
    EibeFrank and Lars Kotthoff
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class weka.gui.explorer.ClassifierPanel

      `weka.gui.explorer.ClassifierPanel.ClassifierPanelDefaults, weka.gui.explorer.ClassifierPanel.TestMode`

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AutoWEKAClassifier` | `aw` The Auto-WEKA classifier.
    `protected weka.gui.PropertyPanel` | `m_CEPanel` The panel showing the current classifier selection.
    `protected javax.swing.JComboBox` | `m_ClassCombo` Lets the user select the class column.
    `protected weka.gui.GenericObjectEditor` | `m_ClassifierEditor` Lets the user configure the classifier.
    `protected weka.gui.explorer.Explorer` | `m_Explorer` the parent frame.
    `protected weka.gui.ResultHistoryPanel` | `m_History` A panel controlling results viewing.
    `protected weka.core.Instances` | `m_Instances` The main set of instances we're playing with.
    `protected weka.gui.Logger` | `m_Log` The destination for log/status messages.
    `protected javax.swing.JButton` | `m_ManualBut` Click to download manual.
    `protected javax.swing.JTextArea` | `m_OutText` The output area for classification results.
    `protected java.lang.Thread` | `m_RunThread` A thread that classification runs in.
    `protected weka.gui.SaveBuffer` | `m_SaveOut` The buffer saving object for saving output.
    `protected javax.swing.JButton` | `m_StartBut` Click to start running the experiment.
    `protected javax.swing.JButton` | `m_StopBut` Click to stop a running experiment.

    - ### Fields inherited from class weka.gui.explorer.ClassifierPanel

      `m_ClassificationOutputEditor, m_ClassificationOutputPanel, m_CollectPredictionsForEvaluationBut, m_CostMatrixEditor, m_CVBut, m_CVLab, m_CVText, m_errorPlotPointSizeProportionalToMargin, m_EvalWRTCostsBut, m_FileChooser, m_initialSettingsSet, m_ModelFilter, m_OutputAdditionalAttributesRange, m_OutputConfusionBut, m_OutputEntropyBut, m_OutputModelBut, m_OutputModelsForTrainingSplitsBut, m_OutputPerClassBut, m_OutputSourceCode, m_PercentBut, m_PercentLab, m_PercentText, m_PMMLModelFilter, m_PreserveOrderBut, m_RandomLab, m_RandomSeedText, m_selectedEvalMetrics, m_SetCostsBut, m_SetCostsFrame, m_SetTestBut, m_SetTestFrame, m_SourceCodeClass, m_StoreTestDataAndPredictionsBut, m_TestClassIndex, m_TestLoader, m_TestSplitBut, m_TrainBut, MODEL_FILE_EXTENSION, PMML_FILE_EXTENSION`

    - ### Fields inherited from class weka.gui.AbstractPerspective

      `m_isActive, m_isLoaded, m_log, m_mainApplication, m_perspectiveIcon, m_perspectiveID, m_perspectiveTipText, m_perspectiveTitle`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AutoWEKAPanel()` Creates the Auto-WEKA panel.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `weka.gui.explorer.Explorer` | `getExplorer()` returns the parent Explorer frame.
    `java.lang.String` | `getTabTitle()` Returns the title for the tab in the Explorer.
    `java.lang.String` | `getTabTitleToolTip()` Returns the tooltip for the tab in the Explorer.
    `static void` | `main(java.lang.String[] args)` Tests out the Auto-WEKA panel from the command line.
    `protected void` | `saveBuffer(java.lang.String name)` Save the currently selected experiment output to a file.
    `void` | `setExplorer(weka.gui.explorer.Explorer parent)` Sets the Explorer to use as parent frame (used for sending notifications about changes in the data).
    `void` | `setInstances(weka.core.Instances inst)` Tells the panel to use a new set of instances.
    `void` | `setLog(weka.gui.Logger newLog)` Sets the Logger to receive informational messages.
    `protected void` | `showPopup(java.lang.String name, int x, int y)` Handles constructing a popup menu with visualization options.
    `protected void` | `startAutoWEKA()` Starts Auto-WEKA.
    `protected void` | `stopAutoWEKA()` Stops the currently running Auto-WEKA (if any).

    - ### Methods inherited from class weka.gui.explorer.ClassifierPanel

      `acceptsInstances, capabilitiesFilterChanged, continueIterating, getClassificationOutputFormatter, getClassifier, getCostMatrix, getDefaultSettings, getInstances, getLog, getNumCVFolds, getPercentageSplit, getRandomSeed, getResultHistory, getSelectedClassIndex, getSeparateTestSetClassIndex, getSeparateTestSetLoader, getSourceCodeClassName, isSelectedCollectPredictionsForEvaluation, isSelectedCV, isSelectedEvalWithRespectToCosts, isSelectedOutputConfusion, isSelectedOutputEntropy, isSelectedOutputModel, isSelectedOutputModelsForTrainingSplits, isSelectedOutputPerClassStats, isSelectedOutputSourceCode, isSelectedPercentageSplit, isSelectedPreserveOrder, isSelectedSeparateTestSet, isSelectedStoreTestDataAndPredictions, isSelectedTestOnTrain, loadClassifier, okToBeActive, printPredictionsHeader, reevaluateModel, requiresLog, saveClassifier, setActive, setTestSet, settingsChanged, setupEval, setupEval, startClassifier, stopClassifier, updateCapabilitiesFilter, updateRadioLinks, visualize, visualizeBayesNet, visualizeClassifierErrors, visualizeCostBenefitAnalysis, visualizeTree`

    - ### Methods inherited from class weka.gui.AbstractPerspective

      `getMainApplication, getMenus, getPerspectiveIcon, getPerspectiveID, getPerspectiveTipText, getPerspectiveTitle, instantiationComplete, setLoaded, setMainApplication, terminate, toString`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### m_Explorer

          protected weka.gui.explorer.Explorer m_Explorer

      the parent frame.

    - #### m_OutText

          protected javax.swing.JTextArea m_OutText

      The output area for classification results.

    - #### m_Log

          protected weka.gui.Logger m_Log

      The destination for log/status messages.

    - #### m_SaveOut

          protected weka.gui.SaveBuffer m_SaveOut

      The buffer saving object for saving output.

    - #### m_History

          protected weka.gui.ResultHistoryPanel m_History

      A panel controlling results viewing.

    - #### m_ClassCombo

          protected javax.swing.JComboBox m_ClassCombo

      Lets the user select the class column.

    - #### m_ManualBut

          protected javax.swing.JButton m_ManualBut

      Click to download manual.

    - #### m_StartBut

          protected javax.swing.JButton m_StartBut

      Click to start running the experiment.

    - #### m_StopBut

          protected javax.swing.JButton m_StopBut

      Click to stop a running experiment.

    - #### m_ClassifierEditor

          protected weka.gui.GenericObjectEditor m_ClassifierEditor

      Lets the user configure the classifier.

    - #### m_CEPanel

          protected weka.gui.PropertyPanel m_CEPanel

      The panel showing the current classifier selection.

    - #### m_Instances

          protected weka.core.Instances m_Instances

      The main set of instances we're playing with.

    - #### m_RunThread

          protected java.lang.Thread m_RunThread

      A thread that classification runs in.

    - #### aw

          protected AutoWEKAClassifier aw

      The Auto-WEKA classifier.

  - ### Constructor Detail

    - #### AutoWEKAPanel

          public AutoWEKAPanel()

      Creates the Auto-WEKA panel.

  - ### Method Detail

    - #### setLog

          public void setLog(weka.gui.Logger newLog)

      Sets the Logger to receive informational messages.
      Specified by:
        `setLog` in interface `weka.gui.explorer.Explorer.LogHandler`
      Specified by:
        `setLog` in interface `weka.gui.Perspective`
      Overrides:
        `setLog` in class `weka.gui.explorer.ClassifierPanel`
      Parameters:
        `newLog` - the Logger that will now get info messages

    - #### setInstances

          public void setInstances(weka.core.Instances inst)

      Tells the panel to use a new set of instances.
      Specified by:
        `setInstances` in interface `weka.gui.explorer.Explorer.ExplorerPanel`
      Specified by:
        `setInstances` in interface `weka.gui.Perspective`
      Overrides:
        `setInstances` in class `weka.gui.explorer.ClassifierPanel`
      Parameters:
        `inst` - a set of Instances

    - #### showPopup

          protected void showPopup(java.lang.String name,
                                   int x,
                                   int y)

      Handles constructing a popup menu with visualization options.
      Parameters:
        `name` - the name of the result history list entry clicked on by the user
        `x` - the x coordinate for popping up the menu
        `y` - the y coordinate for popping up the menu

    - #### startAutoWEKA

          protected void startAutoWEKA()

      Starts Auto-WEKA. This is run in a separate thread, and will only start if there is no Auto-WEKA thread already running. The output is sent to the results history panel.

    - #### saveBuffer

          protected void saveBuffer(java.lang.String name)

      Save the currently selected experiment output to a file.
      Overrides:
        `saveBuffer` in class `weka.gui.explorer.ClassifierPanel`
      Parameters:
        `name` - the name of the buffer to save

    - #### stopAutoWEKA

          protected void stopAutoWEKA()

      Stops the currently running Auto-WEKA (if any).

    - #### setExplorer

          public void setExplorer(weka.gui.explorer.Explorer parent)

      Sets the Explorer to use as parent frame (used for sending notifications about changes in the data).
      Specified by:
        `setExplorer` in interface `weka.gui.explorer.Explorer.ExplorerPanel`
      Overrides:
        `setExplorer` in class `weka.gui.explorer.ClassifierPanel`
      Parameters:
        `parent` - the parent frame

    - #### getExplorer

          public weka.gui.explorer.Explorer getExplorer()

      returns the parent Explorer frame.
      Specified by:
        `getExplorer` in interface `weka.gui.explorer.Explorer.ExplorerPanel`
      Overrides:
        `getExplorer` in class `weka.gui.explorer.ClassifierPanel`
      Returns:
        the parent

    - #### getTabTitle

          public java.lang.String getTabTitle()

      Returns the title for the tab in the Explorer.
      Specified by:
        `getTabTitle` in interface `weka.gui.explorer.Explorer.ExplorerPanel`
      Overrides:
        `getTabTitle` in class `weka.gui.explorer.ClassifierPanel`
      Returns:
        the title of this tab

    - #### getTabTitleToolTip

          public java.lang.String getTabTitleToolTip()

      Returns the tooltip for the tab in the Explorer.
      Specified by:
        `getTabTitleToolTip` in interface `weka.gui.explorer.Explorer.ExplorerPanel`
      Overrides:
        `getTabTitleToolTip` in class `weka.gui.explorer.ClassifierPanel`
      Returns:
        the tooltip of this tab

    - #### main

          public static void main(java.lang.String[] args)

      Tests out the Auto-WEKA panel from the command line.
      Parameters:
        `args` - may optionally contain the name of a dataset to load.